(function ($, Drupal, debounce) {

  Drupal.behaviors.improvementsForm = {
    attach: function attach(context, settings) {
      if (context.tagName == 'SCRIPT') {
        return;
      }

      // Trigger "typingstop" and "change" events after user stopped typing in textfield.
      // each() used because Drupal.debounce() needs separate instance on each element.
      $('input[type="text"], input[type="number"]', context).once('typingstop').each(function () {
        var $input = $(this);
        var timeout = $input.data('typing-timeout') ? $input.data('typing-timeout') : 600;

        $input.on('keyup', debounce(function (event) {
          $input.trigger('typingstop');

          // If element unfocused then "change" event already triggered.
          if ($input.is(':focus')) {
            $input.trigger('change');
          }
        }, timeout))
      });
    }
  };

})(jQuery, Drupal, Drupal.debounce);
