<?php

use Drupal\Core\Site\Settings;
use Drupal\druhels\SeoHelper;
use Drupal\improvements\ImprovementsHelper;

// @TODO Add tests

/**
 * @see improvements_page_attachments()
 */
function improvements_build_time_page_attachments(array &$page): void {
  if (Settings::get('show_build_time')) {
    SeoHelper::attachMetatag($page, 'meta_build_time', 'page-build-time', ImprovementsHelper::getBuildTime());
  }
}

/**
 * @see improvements_preprocess_block()
 */
function improvements_build_time_preprocess_block(array &$vars): void {
  if (Settings::get('show_build_time')) {
    $vars['title_prefix']['build_time'] = [
      '#type' => 'meta_tag',
      '#name' => 'block-build-time',
      '#content' => ImprovementsHelper::getBuildTime(),
    ];
  }
}

/**
 * @see improvements_preprocess_views_view()
 */
function improvements_build_time_preprocess_views_view(array &$vars): void {
  if (Settings::get('show_build_time')) {
    $vars['title_prefix']['build_time'] = [
      '#type' => 'meta_tag',
      '#name' => 'views-build-time',
      '#content' => ImprovementsHelper::getBuildTime(),
    ];
  }
}

/**
 * Preprocess function for node.gtml.twig.
 */
function improvements_preprocess_node(array &$vars): void {
  if (Settings::get('show_build_time')) {
    $vars['title_prefix']['build_time'] = [
      '#type' => 'meta_tag',
      '#name' => 'node-build-time',
      '#content' => ImprovementsHelper::getBuildTime(),
    ];
  }
}
