<?php

use Drupal\Core\Entity\EntityTypeInterface;
use Drupal\Core\Field\BaseFieldDefinition;

/**
 * Implements hook_page_ROUTE_NAME_result_alter(): comment.reply.
 */
function improvements_page_comment_reply_result_alter(array &$result): void {
  // Hide commented entity on comment form page
  if (isset($result['commented_entity'])) {
    $result['commented_entity']['#access'] = FALSE;
  }
}

/**
 * Implements hook_entity_base_field_info_alter().
 *
 * @param BaseFieldDefinition[] $fields
 *
 * @see improvements_entity_base_field_info_alter()
 */
function improvements_comment_entity_base_field_info_alter(array &$fields, EntityTypeInterface $entity_type): void {
  if ($entity_type->id() == 'comment') {
    // Add comment author and date on comment view display
    /** @see \Drupal\comment\Entity\Comment::baseFieldDefinitions() */
    $fields['uid']->setDisplayConfigurable('view', TRUE);
    $fields['created']->setDisplayConfigurable('view', TRUE);

    $fields['created']->setLabel('Creation date');
    $fields['changed']->setLabel(t('Change date'));
  }
}
