<?php

namespace Drupal\improvements\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\Plugin\Field\FieldFormatter\NumericFormatterBase;

/**
 * @FieldFormatter(
 *   id = "number_raw",
 *   label = @Translation("Raw"),
 *   field_types = {
 *     "decimal",
 *     "float",
 *   }
 * )
 */
class NumericRawFormatter extends NumericFormatterBase {

  /**
   * {@inheritdoc}
   */
  public static function defaultSettings(): array {
    return [
      'prefix_suffix' => TRUE,
    ] + parent::defaultSettings();
  }

  /**
   * {@inheritDoc}
   */
  protected function numberFormat($number): string {
    return $number;
  }

}
